JacksonAnnotationIntrospector (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.introspect

## Class JacksonAnnotationIntrospector

- java.lang.Object
- - org.codehaus.jackson.map.AnnotationIntrospector
  - - org.codehaus.jackson.map.introspect.JacksonAnnotationIntrospector

-     public class JacksonAnnotationIntrospector
      extends AnnotationIntrospector

  `AnnotationIntrospector` implementation that handles standard Jackson annotations.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.AnnotationIntrospector

      `AnnotationIntrospector.Pair, AnnotationIntrospector.ReferenceProperty`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JacksonAnnotationIntrospector()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected StdTypeResolverBuilder` | `_constructNoTypeResolverBuilder()` Helper method for dealing with "no type info" marker; can't be null (as it'd be replaced by default typing)
    `protected StdTypeResolverBuilder` | `_constructStdTypeResolverBuilder()` Helper method for constructing standard `TypeResolverBuilder` implementation.
    `protected TypeResolverBuilder<?>` | `_findTypeResolver(MapperConfig<?> config, Annotated ann, JavaType baseType)` Helper method called to construct and initialize instance of `TypeResolverBuilder` if given annotated element indicates one is needed.
    `protected boolean` | `_isIgnorable(Annotated a)`
    `VisibilityChecker<?>` | `findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)` Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors).
    `Boolean` | `findCachability(AnnotatedClass ac)` Method that checks whether specified class has annotations that indicate that it is (or is not) cachable.
    `Class<? extends JsonDeserializer<?>>` | `findContentDeserializer(Annotated a)` Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property.
    `Class<? extends JsonSerializer<?>>` | `findContentSerializer(Annotated a)` Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property.
    `String` | `findDeserializablePropertyName(AnnotatedField af)` Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property.
    `Class<?>` | `findDeserializationContentType(Annotated am, JavaType baseContentType, String propName)` Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements.
    `Class<?>` | `findDeserializationKeyType(Annotated am, JavaType baseKeyType, String propName)` Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use.
    `Class<?>` | `findDeserializationType(Annotated am, JavaType baseType, String propName)` Method for accessing annotated type definition that a method can have, to be used as the type for serialization instead of the runtime type.
    `Class<? extends JsonDeserializer<?>>` | `findDeserializer(Annotated a)` Method for getting a deserializer definition on specified method or field.
    `String` | `findEnumValue(Enum<?> value)` Method for determining the String value to use for serializing given enumeration entry; used when serializing enumerations as Strings (the standard method).
    `Object` | `findFilterId(AnnotatedClass ac)` Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.
    `String` | `findGettablePropertyName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter".
    `Boolean` | `findIgnoreUnknownProperties(AnnotatedClass ac)` Method for checking whether an annotation indicates that all unknown properties
    `Object` | `findInjectableValueId(AnnotatedMember m)` Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection.
    `Class<? extends KeyDeserializer>` | `findKeyDeserializer(Annotated a)` Method for getting a deserializer definition for keys of associated `Map` property.
    `Class<? extends JsonSerializer<?>>` | `findKeySerializer(Annotated a)` Method for getting a serializer definition for keys of associated `Map` property.
    `String[]` | `findPropertiesToIgnore(AnnotatedClass ac)` Method for finding list of properties to ignore for given class (null is returned if not specified).
    `TypeResolverBuilder<?>` | `findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType containerType)` Since 1.7, it is possible to use `JsonTypeInfo` from a property too.
    `String` | `findPropertyNameForParam(AnnotatedParameter param)` Method for checking whether given set of annotations indicates property name for associated parameter.
    `TypeResolverBuilder<?>` | `findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)` Since 1.7, it is possible to use `JsonTypeInfo` from a property too.
    `AnnotationIntrospector.ReferenceProperty` | `findReferenceType(AnnotatedMember member)` Note: defined as non-abstract to reduce fragility between versions.
    `String` | `findRootName(AnnotatedClass ac)` Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined.
    `String` | `findSerializablePropertyName(AnnotatedField af)` Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property.
    `Class<?>` | `findSerializationContentType(Annotated am, JavaType baseType)` Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization.
    `JsonSerialize.Inclusion` | `findSerializationInclusion(Annotated a, JsonSerialize.Inclusion defValue)` Method for checking whether given annotated entity (class, method, field) defines which Bean/Map properties are to be included in serialization.
    `Class<?>` | `findSerializationKeyType(Annotated am, JavaType baseType)` Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization.
    `String[]` | `findSerializationPropertyOrder(AnnotatedClass ac)` Method for accessing defined property serialization order (which may be partial).
    `Boolean` | `findSerializationSortAlphabetically(AnnotatedClass ac)` Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
    `Class<?>` | `findSerializationType(Annotated am)` Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type.
    `JsonSerialize.Typing` | `findSerializationTyping(Annotated a)` Method for accessing declared typing mode annotated (if any).
    `Class<?>[]` | `findSerializationViews(Annotated a)` Method for checking if annotated serializable property (represented by field or getter method) has definitions for views it is to be included in.
    `Object` | `findSerializer(Annotated a)` Method for getting a serializer definition on specified method or field.
    `String` | `findSettablePropertyName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter".
    `List<NamedType>` | `findSubtypes(Annotated a)` Method for locating annotation-specified subtypes related to annotated entity (class, method, field).
    `String` | `findTypeName(AnnotatedClass ac)` Method for checking if specified type has explicit name.
    `TypeResolverBuilder<?>` | `findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)` Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances.
    `Object` | `findValueInstantiator(AnnotatedClass ac)` Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.
    `boolean` | `hasAnyGetterAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.
    `boolean` | `hasAnySetterAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
    `boolean` | `hasAsValueAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
    `boolean` | `hasCreatorAnnotation(Annotated a)` Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.
    `boolean` | `hasIgnoreMarker(AnnotatedMember m)` Method called to check whether given property is marked to be ignored; but NOT to determine if it should necessarily be ignored, since that may depend on other factors.
    `boolean` | `isHandled(Annotation ann)` Method called by framework to determine whether given annotation is handled by this introspector.
    `boolean` | `isIgnorableConstructor(AnnotatedConstructor c)`
    `boolean` | `isIgnorableField(AnnotatedField f)` Method for checking whether there is an annotation that indicates that given field should be ignored for all operations (serialization, deserialization).
    `boolean` | `isIgnorableMethod(AnnotatedMethod m)` Method for checking whether there is an annotation that indicates that given method should be ignored for all operations (serialization, deserialization).
    `Boolean` | `isIgnorableType(AnnotatedClass ac)` Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
    `Boolean` | `shouldUnwrapProperty(AnnotatedMember member)` Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e.

    - ### Methods inherited from class org.codehaus.jackson.map.AnnotationIntrospector

      `allIntrospectors, allIntrospectors, nopInstance, pair`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JacksonAnnotationIntrospector

          public JacksonAnnotationIntrospector()

  - ### Method Detail

    - #### isHandled

          public boolean isHandled(Annotation ann)

      Description copied from class: `AnnotationIntrospector`
      Method called by framework to determine whether given annotation is handled by this introspector.
      Specified by:
        `isHandled` in class `AnnotationIntrospector`

    - #### findEnumValue

          public String findEnumValue(Enum<?> value)

      Description copied from class: `AnnotationIntrospector`
      Method for determining the String value to use for serializing given enumeration entry; used when serializing enumerations as Strings (the standard method).

      NOTE: implemented since 1.9.11, to make things work even when annotation introspection is disabled.

      Overrides:
        `findEnumValue` in class `AnnotationIntrospector`
      Returns:
        Serialized enum value.

    - #### findCachability

          public Boolean findCachability(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method that checks whether specified class has annotations that indicate that it is (or is not) cachable. Exact semantics depend on type of class annotated and using class (factory or provider).

      Currently only used with deserializers, to determine whether provider should cache instances, and if no annotations are found, assumes non-cachable instances.

      Overrides:
        `findCachability` in class `AnnotationIntrospector`
      Returns:
        True, if class is considered cachable within context, False if not, and null if introspector does not care either way.

    - #### findRootName

          public String findRootName(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined. Returns null if no declaration found; can return explicit empty String, which is usually ignored as well as null.
      Specified by:
        `findRootName` in class `AnnotationIntrospector`

    - #### findPropertiesToIgnore

          public String[] findPropertiesToIgnore(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for finding list of properties to ignore for given class (null is returned if not specified). List of property names is applied after other detection mechanisms, to filter out these specific properties from being serialized and deserialized.
      Specified by:
        `findPropertiesToIgnore` in class `AnnotationIntrospector`

    - #### findIgnoreUnknownProperties

          public Boolean findIgnoreUnknownProperties(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether an annotation indicates that all unknown properties
      Specified by:
        `findIgnoreUnknownProperties` in class `AnnotationIntrospector`

    - #### isIgnorableType

          public Boolean isIgnorableType(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
      Overrides:
        `isIgnorableType` in class `AnnotationIntrospector`
      Parameters:
        `ac` - Type to check
      Returns:
        Boolean.TRUE if properties of type should be ignored; Boolean.FALSE if they are not to be ignored, null for default handling (which is 'do not ignore')

    - #### findFilterId

          public Object findFilterId(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.
      Overrides:
        `findFilterId` in class `AnnotationIntrospector`
      Returns:
        Id of the filter to use for filtering properties of annotated class, if any; or null if none found.

    - #### findAutoDetectVisibility

          public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac,
                                                      VisibilityChecker<?> checker)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors). A baseline checker is given, and introspector is to either return it as is (if no annotations are found), or build and return a derived instance (using checker's build methods).
      Overrides:
        `findAutoDetectVisibility` in class `AnnotationIntrospector`

    - #### findReferenceType

          public AnnotationIntrospector.ReferenceProperty findReferenceType(AnnotatedMember member)

      Description copied from class: `AnnotationIntrospector`
      Note: defined as non-abstract to reduce fragility between versions.
      Overrides:
        `findReferenceType` in class `AnnotationIntrospector`

    - #### shouldUnwrapProperty

          public Boolean shouldUnwrapProperty(AnnotatedMember member)

      Description copied from class: `AnnotationIntrospector`
      Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e. expect unwrapped representation during deserialization)
      Overrides:
        `shouldUnwrapProperty` in class `AnnotationIntrospector`

    - #### hasIgnoreMarker

          public boolean hasIgnoreMarker(AnnotatedMember m)

      Description copied from class: `AnnotationIntrospector`
      Method called to check whether given property is marked to be ignored; but NOT to determine if it should necessarily be ignored, since that may depend on other factors.

      Default implementation calls existing 'isIgnored' methods such as `AnnotationIntrospector.isIgnorableField(AnnotatedField)` and `AnnotationIntrospector.isIgnorableMethod(AnnotatedMethod)`.

      Overrides:
        `hasIgnoreMarker` in class `AnnotationIntrospector`

    - #### findInjectableValueId

          public Object findInjectableValueId(AnnotatedMember m)

      Description copied from class: `AnnotationIntrospector`
      Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection. Type if identifier needs to be compatible with provider of values (of type `InjectableValues`); often a simple String id is used.
      Overrides:
        `findInjectableValueId` in class `AnnotationIntrospector`
      Parameters:
        `m` - Member to check
      Returns:
        Identifier of value to inject, if any; null if no injection indicator is found

    - #### findTypeResolver

          public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config,
                                                AnnotatedClass ac,
                                                JavaType baseType)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(org.codehaus.jackson.map.introspect.Annotated)`
      Overrides:
        `findTypeResolver` in class `AnnotationIntrospector`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `ac` - Annotated class to check for annotations
        `baseType` - Base java type of value for which resolver is to be found
      Returns:
        Type resolver builder for given type, if one found; null if none

    - #### findPropertyTypeResolver

          public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config,
                                                        AnnotatedMember am,
                                                        JavaType baseType)

      Since 1.7, it is possible to use `JsonTypeInfo` from a property too.
      Overrides:
        `findPropertyTypeResolver` in class `AnnotationIntrospector`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `am` - Annotated member (field or method) to check for annotations
        `baseType` - Base java type of property for which resolver is to be found
      Returns:
        Type resolver builder for properties of given entity, if one found; null if none

    - #### findPropertyContentTypeResolver

          public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config,
                                                               AnnotatedMember am,
                                                               JavaType containerType)

      Since 1.7, it is possible to use `JsonTypeInfo` from a property too.
      Overrides:
        `findPropertyContentTypeResolver` in class `AnnotationIntrospector`
      Parameters:
        `config` - Configuration settings in effect (for serialization or deserialization)
        `am` - Annotated member (field or method) to check for annotations
        `containerType` - Type of property for which resolver is to be found (must be a container type)
      Returns:
        Type resolver builder for values contained in properties of given entity, if one found; null if none

    - #### findSubtypes

          public List<NamedType> findSubtypes(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for locating annotation-specified subtypes related to annotated entity (class, method, field). Note that this is only guaranteed to be a list of directly declared subtypes, no recursive processing is guarantees (i.e. caller has to do it if/as necessary)
      Overrides:
        `findSubtypes` in class `AnnotationIntrospector`
      Parameters:
        `a` - Annotated entity (class, field/method) to check for annotations

    - #### findTypeName

          public String findTypeName(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if specified type has explicit name.
      Overrides:
        `findTypeName` in class `AnnotationIntrospector`
      Parameters:
        `ac` - Class to check for type name annotations

    - #### isIgnorableMethod

          public boolean isIgnorableMethod(AnnotatedMethod m)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether there is an annotation that indicates that given method should be ignored for all operations (serialization, deserialization).

      Note that this method should ONLY return true for such explicit ignoral cases; and not if method just happens not to be visible for annotation processor.

      Specified by:
        `isIgnorableMethod` in class `AnnotationIntrospector`
      Returns:
        True, if an annotation is found to indicate that the method should be ignored; false if not.

    - #### isIgnorableConstructor

          public boolean isIgnorableConstructor(AnnotatedConstructor c)

      Specified by:
        `isIgnorableConstructor` in class `AnnotationIntrospector`

    - #### isIgnorableField

          public boolean isIgnorableField(AnnotatedField f)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether there is an annotation that indicates that given field should be ignored for all operations (serialization, deserialization).
      Specified by:
        `isIgnorableField` in class `AnnotationIntrospector`
      Returns:
        True, if an annotation is found to indicate that the field should be ignored; false if not.

    - #### findSerializer

          public Object findSerializer(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a serializer definition on specified method or field. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.

      Note: this variant was briefly deprecated for 1.7; should not be

      Specified by:
        `findSerializer` in class `AnnotationIntrospector`

    - #### findKeySerializer

          public Class<? extends JsonSerializer<?>> findKeySerializer(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a serializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Overrides:
        `findKeySerializer` in class `AnnotationIntrospector`

    - #### findContentSerializer

          public Class<? extends JsonSerializer<?>> findContentSerializer(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Overrides:
        `findContentSerializer` in class `AnnotationIntrospector`

    - #### findSerializationInclusion

          public JsonSerialize.Inclusion findSerializationInclusion(Annotated a,
                                                           JsonSerialize.Inclusion defValue)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given annotated entity (class, method, field) defines which Bean/Map properties are to be included in serialization. If no annotation is found, method should return given second argument; otherwise value indicated by the annotation
      Overrides:
        `findSerializationInclusion` in class `AnnotationIntrospector`
      Returns:
        Enumerated value indicating which properties to include in serialization

    - #### findSerializationType

          public Class<?> findSerializationType(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type. Type returned (if any) needs to be widening conversion (super-type). Declared return type of the method is also considered acceptable.
      Specified by:
        `findSerializationType` in class `AnnotationIntrospector`
      Returns:
        Class to use instead of runtime type

    - #### findSerializationKeyType

          public Class<?> findSerializationKeyType(Annotated am,
                                          JavaType baseType)

      Description copied from class: `AnnotationIntrospector`
      Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization. It should be only be used with `Map` types.
      Overrides:
        `findSerializationKeyType` in class `AnnotationIntrospector`
      Returns:
        Class specifying more general type to use instead of declared type, if annotation found; null if not

    - #### findSerializationContentType

          public Class<?> findSerializationContentType(Annotated am,
                                              JavaType baseType)

      Description copied from class: `AnnotationIntrospector`
      Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization. It should be only used with structured types (arrays, collections, maps).
      Overrides:
        `findSerializationContentType` in class `AnnotationIntrospector`
      Returns:
        Class specifying more general type to use instead of declared type, if annotation found; null if not

    - #### findSerializationTyping

          public JsonSerialize.Typing findSerializationTyping(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing declared typing mode annotated (if any). This is used for type detection, unless more granular settings (such as actual exact type; or serializer to use which means no type information is needed) take precedence.
      Specified by:
        `findSerializationTyping` in class `AnnotationIntrospector`
      Returns:
        Typing mode to use, if annotation is found; null otherwise

    - #### findSerializationViews

          public Class<?>[] findSerializationViews(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if annotated serializable property (represented by field or getter method) has definitions for views it is to be included in. If null is returned, no view definitions exist and property is always included; otherwise it will only be included for views included in returned array. View matches are checked using class inheritance rules (sub-classes inherit inclusions of super-classes)
      Specified by:
        `findSerializationViews` in class `AnnotationIntrospector`
      Parameters:
        `a` - Annotated serializable property (field or getter method)
      Returns:
        Array of views (represented by classes) that the property is included in; if null, always included (same as returning array containing `Object.class`)

    - #### findSerializationPropertyOrder

          public String[] findSerializationPropertyOrder(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing defined property serialization order (which may be partial). May return null if no ordering is defined.
      Specified by:
        `findSerializationPropertyOrder` in class `AnnotationIntrospector`

    - #### findSerializationSortAlphabetically

          public Boolean findSerializationSortAlphabetically(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
      Specified by:
        `findSerializationSortAlphabetically` in class `AnnotationIntrospector`

    - #### findGettablePropertyName

          public String findGettablePropertyName(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".
      Specified by:
        `findGettablePropertyName` in class `AnnotationIntrospector`

    - #### hasAsValueAnnotation

          public boolean hasAsValueAnnotation(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
      Specified by:
        `hasAsValueAnnotation` in class `AnnotationIntrospector`
      Returns:
        True if such annotation is found (and is not disabled); false if no enabled annotation is found

    - #### findSerializablePropertyName

          public String findSerializablePropertyName(AnnotatedField af)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a serializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".
      Specified by:
        `findSerializablePropertyName` in class `AnnotationIntrospector`

    - #### findDeserializer

          public Class<? extends JsonDeserializer<?>> findDeserializer(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition on specified method or field. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.

      Note: this variant was briefly deprecated for 1.7; but it turns out we really should not try to push BeanProperty through at this point

      Specified by:
        `findDeserializer` in class `AnnotationIntrospector`

    - #### findKeyDeserializer

          public Class<? extends KeyDeserializer> findKeyDeserializer(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Specified by:
        `findKeyDeserializer` in class `AnnotationIntrospector`

    - #### findContentDeserializer

          public Class<? extends JsonDeserializer<?>> findContentDeserializer(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Specified by:
        `findContentDeserializer` in class `AnnotationIntrospector`

    - #### findDeserializationType

          public Class<?> findDeserializationType(Annotated am,
                                         JavaType baseType,
                                         String propName)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing annotated type definition that a method can have, to be used as the type for serialization instead of the runtime type. Type must be a narrowing conversion (i.e.subtype of declared type). Declared return type of the method is also considered acceptable.
      Specified by:
        `findDeserializationType` in class `AnnotationIntrospector`
        `baseType` - Assumed type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class to use for deserialization instead of declared type

    - #### findDeserializationKeyType

          public Class<?> findDeserializationKeyType(Annotated am,
                                            JavaType baseKeyType,
                                            String propName)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use. It should be only be used with `Map` types.
      Specified by:
        `findDeserializationKeyType` in class `AnnotationIntrospector`
        `baseKeyType` - Assumed key type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class specifying more specific type to use instead of declared type, if annotation found; null if not

    - #### findDeserializationContentType

          public Class<?> findDeserializationContentType(Annotated am,
                                                JavaType baseContentType,
                                                String propName)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements. It should be only be used with Map, Collection and array types.
      Specified by:
        `findDeserializationContentType` in class `AnnotationIntrospector`
        `baseContentType` - Assumed content (value) type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class specifying more specific type to use instead of declared type, if annotation found; null if not

    - #### findValueInstantiator

          public Object findValueInstantiator(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.
      Overrides:
        `findValueInstantiator` in class `AnnotationIntrospector`

    - #### findSettablePropertyName

          public String findSettablePropertyName(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".
      Specified by:
        `findSettablePropertyName` in class `AnnotationIntrospector`

    - #### hasAnySetterAnnotation

          public boolean hasAnySetterAnnotation(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
      Overrides:
        `hasAnySetterAnnotation` in class `AnnotationIntrospector`
      Returns:
        True if such annotation is found (and is not disabled), false otherwise

    - #### hasAnyGetterAnnotation

          public boolean hasAnyGetterAnnotation(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.
      Overrides:
        `hasAnyGetterAnnotation` in class `AnnotationIntrospector`
      Returns:
        True if such annotation is found (and is not disabled), false otherwise

    - #### hasCreatorAnnotation

          public boolean hasCreatorAnnotation(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.
      Overrides:
        `hasCreatorAnnotation` in class `AnnotationIntrospector`
      Returns:
        True if such annotation is found (and is not disabled), false otherwise

    - #### findDeserializablePropertyName

          public String findDeserializablePropertyName(AnnotatedField af)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a deserializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".
      Specified by:
        `findDeserializablePropertyName` in class `AnnotationIntrospector`

    - #### findPropertyNameForParam

          public String findPropertyNameForParam(AnnotatedParameter param)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given set of annotations indicates property name for associated parameter. No actual parameter object can be passed since JDK offers no representation; just annotations.
      Specified by:
        `findPropertyNameForParam` in class `AnnotationIntrospector`

    - #### _isIgnorable

          protected boolean _isIgnorable(Annotated a)

    - #### _findTypeResolver

          protected TypeResolverBuilder<?> _findTypeResolver(MapperConfig<?> config,
                                                 Annotated ann,
                                                 JavaType baseType)

      Helper method called to construct and initialize instance of `TypeResolverBuilder` if given annotated element indicates one is needed.

    - #### _constructStdTypeResolverBuilder

          protected StdTypeResolverBuilder _constructStdTypeResolverBuilder()

      Helper method for constructing standard `TypeResolverBuilder` implementation.
      Since:
        1.7

    - #### _constructNoTypeResolverBuilder

          protected StdTypeResolverBuilder _constructNoTypeResolverBuilder()

      Helper method for dealing with "no type info" marker; can't be null (as it'd be replaced by default typing)
      Since:
        1.9.4